package edu.dhbw.concurrent;

public class Beispiel2 {

    public static double globaleSumme = 0.0;

    public static void main(String[] args) {
        int anzahl = 300000;
        int worker = 13;
        int teilanzahl = anzahl / worker;
        if (anzahl % worker != 0) {
            teilanzahl++;
        }
        RunBsp2[] th = new RunBsp2[worker];
        for (int i = 0; i < worker; i++) {
            int low = i * teilanzahl;
            int up = (i + 1) * teilanzahl;
            up = Math.min(up, anzahl);
            th[i] = new RunBsp2(i, low, up);
        }
        for (int i = 0; i < worker; i++) {
            th[i].start();
        }
        System.out.println("Threads started");
        for (int i = 0; i < worker; i++) {
            try {
                th[i].join();
            } catch (InterruptedException e) {
                // e.printStackTrace();
            }
        }
        System.out.println("threads terminated, summe = " + globaleSumme);
        // System.exit(0);
    }
}

class RunBsp2 extends Thread {
    int lower;
    int upper;
    int id;
    double summe;

    public RunBsp2(int i, int l, int u) {
        lower = l;
        upper = u;
        id = i;
    }

    public void run() {
        double s = 0.0;
        for (int i = lower; i < upper; i++) {
            s += Math.cos(i);
        }
        summe = s;
        System.out.println("Thread[" + id + "], anzahl = " + (upper - lower)
                + ", summe = " + s);
        synchronized (Beispiel2.class) {
            s = Beispiel2.globaleSumme;
            s += summe;
            try {
                Thread.sleep((int) (Math.random() * 50));
            } catch (InterruptedException e) {
            }
            Beispiel2.globaleSumme = s;
        }
    }
}
