package edu.dhbw.concurrent;

public class Beispiel2a {

    public static double globaleSumme = 0.0;

    public static void main(String[] args) {
        int anzahl = 3000000;
        int worker = 13;
        int teilanzahl = anzahl / worker;
        if (anzahl % worker != 0) {
            teilanzahl++;
        }
        Ergebnis erg = new Ergebnis(0.0);
        System.out.println("erg = " + erg.get());
        RunBsp2a[] th = new RunBsp2a[worker];
        for (int i = 0; i < worker; i++) {
            int low = i * teilanzahl;
            int up = (i + 1) * teilanzahl;
            up = Math.min(up, anzahl);
            th[i] = new RunBsp2a(i, low, up, erg);
        }
        long t = System.currentTimeMillis();
        for (int i = 0; i < worker; i++) {
            th[i].start();
        }
        System.out.println("Threads started");
        for (int i = 0; i < worker; i++) {
            try {
                th[i].join();
            } catch (InterruptedException e) {
                // e.printStackTrace();
            }
        }
        t = System.currentTimeMillis() - t;
        System.out.println("threads terminated in " + t + " ms, summe = "
                + erg.get());
        // System.exit(0);
    }
}

class RunBsp2a extends Thread {
    int lower;
    int upper;
    int id;
    Ergebnis summe;

    public RunBsp2a(int i, int l, int u, Ergebnis s) {
        lower = l;
        upper = u;
        id = i;
        summe = s;
    }

    public void run() {
        double s = 0.0;
        for (int i = lower; i < upper; i++) {
            s += Math.cos(i);
            // summe.addTo(Math.cos(i));
        }
        // synchronized (summe) {
        summe.addTo(s);
        System.out.println("Thread[" + id + "], anzahl = " + (upper - lower)
                + ", summe = " + s + ", erg = " + summe.get());
        // }
    }
}

class Ergebnis { // thread safe
    double summe = 0.0;

    public Ergebnis(double d) {
        summe = d;
    }

    public synchronized void addTo(double d) {
        summe += d;
    }

    public synchronized double get() {
        return summe;
    }
}
