package edu.dhbw.concurrent;

import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;

public class Beispiel6 {

    static int worker = 5;
    static boolean done = false;

    public static void main(String[] args) throws InterruptedException {
        BlockingQueue<Auftrag> queue = new ArrayBlockingQueue<Auftrag>(100);
        ExecutorService pool = Executors.newCachedThreadPool();
        Future[] prod = new Future[worker];
        Future<Integer>[] cons = new Future[worker];
        for (int i = 0; i < worker; i++) {
            prod[i] = pool.submit(new Ueb6Prod(i, queue));
            cons[i] = pool.submit(new Ueb6Cons(i, queue));
        }
        System.out.println("Prod and Cons started");
        // falsch: queue.put(new Ende());
        for (int i = 0; i < worker; i++) {
            try {
                prod[i].get();
            } catch (InterruptedException e) {
                e.printStackTrace();
            } catch (ExecutionException e) {
                e.printStackTrace();
            }
        }
        done = true;
        queue.put(new Ende());
        System.out.println("Prod joined");
        for (int i = 0; i < worker; i++) {
            try {
                Integer x = cons[i].get();
            } catch (InterruptedException | ExecutionException e) {
                e.printStackTrace();
            }
        }
        System.out.println("Cons joined");
        queue.take(); // aufräumen
        System.out.println("#queue = " + queue.size());
        pool.shutdown();
    }

}

class Ueb6Prod extends Thread {
    BlockingQueue<Auftrag> queue;
    int i;

    Ueb6Prod(int i, BlockingQueue<Auftrag> q) {
        queue = q;
        this.i = i;
    }

    public void run() {
        System.out.println("Thread Ueb5Prod " + i + " started");
        for (int j = 0; j < 20; j++) {
            try {
                queue.put(new Auftrag(i * 100 + j));
                Thread.sleep((int) Math.random() * 300);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }
}

class Ueb6Cons implements Callable<Integer> {
    BlockingQueue<Auftrag> queue;
    int i;

    Ueb6Cons(int i, BlockingQueue<Auftrag> q) {
        this.i = i;
        queue = q;
    }

    @Override
    public Integer call() {
        System.out.println("Thread Ueb5Cons " + i + " started");
        for (int j = 0;; j++) {
            try {
                Auftrag x = null;
                x = queue.take();
                if (x instanceof Ende) {
                    queue.put(x);
                    break;
                }
                if (x == null) {
                    continue;
                }
                System.out.println("Cons(" + i + "), x = " + x);
                Thread.sleep((int) Math.random() * 10);
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        return new Integer(i);
    }
}
