package edu.dhbw.concurrent;

public class MatrixParallel extends Matrix {

    public MatrixParallel(double[][] v) {
        super(v);
    }

    public Matrix mult(Matrix B) {
        double[][] Bval = B.val;
        double[][] c = new double[val.length][Bval[0].length];
        Matrix C = new Matrix(c);
        ZeileParallel[] th = new ZeileParallel[val.length];
        for (int i = 0; i < val.length; i++) {
            th[i] = new ZeileParallel(this, B, C, i);
            th[i].start();
        }
        for (int i = 0; i < val.length; i++) {
            try {
                th[i].join();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        return C;
    }
}

class ZeileParallel extends Thread {
    Matrix A, B, C;
    int i;

    public ZeileParallel(Matrix A, Matrix B, Matrix C, int i) {
        this.A = A;
        this.B = B;
        this.C = C;
        this.i = i;
    }

    public void run() {
        double[][] val = A.val;
        double[][] Bval = B.val;
        double[][] Cval = C.val;
        for (int j = 0; j < Bval[0].length; j++) {
            double s = 0.0;
            for (int k = 0; k < val[0].length; k++) {
                s += val[i][k] * Bval[k][j];
            }
            Cval[i][j] = s;
        }
    }
}
