package edu.dhbw.concurrent;

public class Semaphore {

    int s;
    int delayed = 0;

    public Semaphore(int i) {
        s = Math.abs(i);
    }

    public synchronized void aquire() {
        while (s <= 0) {
            try {
                delayed++;
                this.wait();
                delayed--;
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        s--;
    }

    public synchronized void release() {
        s++;
        if (s > 0) {
            if (delayed > 0) {
                this.notify();
            }
        }
    }

    public String toString() {
        return "Semaphore(" + s + ",w=" + delayed + ")";
    }
}
