package edu.dhbw.pv;

public class ParallelMatrixTrans extends Matrix {
    public ParallelMatrixTrans(int n, int m) {
        super(n,m);
    }
    public ParallelMatrixTrans(double [][] v) {
        super(v);
    }
    
    public Matrix multiply(Matrix B) {
        double[][] erg = new double[val.length][B.val[0].length];
        B = B.transpose();
        Thread[] th = new Thread[val.length];
        for (int i = 0;i <val.length; i++ ) {
            th[i] = new ZeilenMultiplikationTrans(erg, val, B.val, i);
            th[i].start();
        }
        for (int i = 0; i < val.length; i++ ) {
            try {
                th[i].join();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
        return new Matrix(erg);
    } 
}

class ZeilenMultiplikationTrans extends Thread {
    double[][] C;
    double[][] A;
    double[][] B;
    int i;
    public ZeilenMultiplikationTrans(double[][] cp, double[][] ap, double[][] bp, int ip) {
        C = cp; A = ap; B = bp; i = ip;      
    }
    public void run() {
        for (int j = 0; j < C[0].length; j++ ) {
            double s = 0.0;
            for (int k = 0; k < A[0].length; k++ ) {
                s += A[i][k] * B[j][k]; // war k,j
            }
            C[i][j] = s;
        }
    }
}
