package edu.dhbw.pv;

public class Uebung3a {

    public static void main(String[] args) {
        int n = 1500;
        int m = n;

        Matrix zero = new Matrix(n, m);
        Matrix one = Matrix.one(n, m);
        Matrix A = Matrix.random(n, m);
        
        //System.out.println("zero = \n" + zero);
        // System.out.println("one = \n" + one);
        //System.out.println("A = \n" + A);
        
        long t = System.currentTimeMillis() ;
        Matrix C = A.multiply(one);
        t = System.currentTimeMillis() - t;
        //System.out.println("C = \n" + C);
        System.out.println("A == C: " + A.equals(C));

        ParallelMatrix Ap = new ParallelMatrix(A.val);
        long tp = System.currentTimeMillis();
        Matrix Cp = Ap.multiply(one);
        tp = System.currentTimeMillis() - tp;
        //System.out.println("Cp = \n" + Cp);
        System.out.println("C == Cp: " + C.equals(Cp));
        
        ParallelMatrixExecutor ApEx = new ParallelMatrixExecutor(A.val, 4);
        long tpex = System.currentTimeMillis();
        Matrix Cpex = ApEx.multiply(one);
        tpex = System.currentTimeMillis() - tpex;
        //System.out.println("Cp = \n" + Cp);
        System.out.println("C == Cpex: " + C.equals(Cpex));
  
        MatrixTrans At = new MatrixTrans(A.val);
        long tt = System.currentTimeMillis();
        Matrix Ct = At.multiply(one);
        tt = System.currentTimeMillis() - tt;
        System.out.println("C == Ct: " + C.equals(Ct));
         
        ParallelMatrixTrans Apt = new ParallelMatrixTrans(A.val);
        long tpt= System.currentTimeMillis();
        Matrix Cpt = Apt.multiply(one);
        tpt = System.currentTimeMillis() - tpt;
        System.out.println("C == Cpt: " + C.equals(Cpt));
        
        ParallelMatrixTransExecutor AptEx = new ParallelMatrixTransExecutor(A.val, 4);
        long tptex= System.currentTimeMillis();
        Matrix Cptex = AptEx.multiply(one);
        tptex = System.currentTimeMillis() - tptex;
        System.out.println("C == Cptex: " + C.equals(Cptex));
        
        System.out.println("sequential              = " + t);
        System.out.println("parallel                = " + tp);
        System.out.println("parallel with Executor  = " + tpex);
        System.out.println("sequential transpose    = " + tt);
        System.out.println("parallel transpose      = " + tpt);
        System.out.println("parallel transpose exec = " + tptex);
    }

}
/* Output on: AMD A8-5600K Four-Core Processor APU with Radeon(tm) HD Graphics @ 3600 MHz

      A == C: true
      C == Cp: true
      C == Cpex: true
      C == Ct: true
      C == Cpt: true
      C == Cptex: true

      sequential              = 36630
      parallel                = 16930
      parallel with Executor  = 16810
      sequential transpose    = 5703
      parallel transpose      = 2362
      parallel transpose exec = 2285
 */

/* Output on: AMD Ryzen 5 1600 Six-Core Processor with SMT/HT @ 3200 MHz

     A == C: true
     C == Cp: true
     C == Cpex: true
     C == Ct: true
     C == Cpt: true
     C == Cptex: true

     sequential              = 9382
     parallel                = 1568
     parallel with Executor  = 2486
     sequential transpose    = 2891
     parallel transpose      = 579
     parallel transpose exec = 835
 */
