package edu.dhbw.pv;

import mpi.MPI;
import mpi.MPIException;
import mpi.Status;

public class Uebung6 {

    public static void main(String[] args) throws MPIException {
	MPI.Init(args);

        //System.out.println("MPI.COMM_WORLD " + MPI.COMM_WORLD);
        //System.out.println("MPI.NUM_OF_PROCESSORS " + MPI.NUM_OF_PROCESSORS );
        //System.out.println("MPI.Get_processor_name " + MPI.Get_processor_name() );

        int me = MPI.COMM_WORLD.Rank();
        int size = MPI.COMM_WORLD.Size();
        System.out.println("Hallo von " + me + " von " + size);

        if (me == 0) {
            char[] message = ("Hello, from " + me + "." ).toCharArray();
            for (int i = 1; i < size; i++) {
                MPI.COMM_WORLD.Send(message, 0, message.length, MPI.CHAR, i, 99);
            }
            message = new char[30];
            for (int i = 1; i < size; i++) {
                Status stat = MPI.COMM_WORLD.Recv(message, 0, message.length, MPI.CHAR, i, 99);
                int count = stat.Get_count(MPI.CHAR); // stat.count                                                  
                String msg = new String(message, 0, count);
                System.out.println("received '" + msg + "' at node " + me + ", Status.count = " + count);
            }
        } else {
            char[] message = new char[20];
            Status stat = MPI.COMM_WORLD.Recv(message, 0, message.length, MPI.CHAR, 0, 99);
            int count = stat.Get_count(MPI.CHAR); // stat.count                                                      
            String msg = new String(message, 0, count);
            System.out.println("received '" + msg + "' at node " + me + ", Status.count = " + count);
            message = ("Hello back, from " + me + "." ).toCharArray();
            MPI.COMM_WORLD.Send(message, 0, message.length, MPI.CHAR, 0, 99);
            System.out.println("done send at " + me);
        }

        MPI.Finalize();
    }

}
