
import java.util.stream.Stream;
import java.util.stream.DoubleStream;
import java.util.concurrent.ThreadLocalRandom;

public class PiRandom {

    public static void main(String[] args) {
        int count = 10_000_000;
        DoubleStream numbers = ThreadLocalRandom.current().doubles(count).parallel(); 
        //Stream<Double> numbers = ThreadLocalRandom.current().doubles(count).parallel().boxed(); 
        System.out.println("numbers = " + numbers);
 
        long inCircle = numbers.filter( x -> { 
                                        double y = ThreadLocalRandom.current().nextDouble(); 
                                        return (x*x + y*y) < 1.0; } )
                               .count();
        //long inCircle = numbers.filter( d -> (d*d*d < 0.5) ).count();
        System.out.println("inCircle = " + inCircle + ", count = " + count);

        double pi = ((double)inCircle)/((double)count)*4.0;
        System.out.println("non Pi = " + pi);        
    }

}
