use structs::Matrix;
use traits::MatrixMult;

impl MatrixMult for Matrix{
    fn mult(&self,b:&Matrix) -> Matrix{
        let rows = self.get_rows();
        let cols = b.get_cols();
        let mut c = Matrix::new(rows,cols);
        for i in 0..rows{
            for j in 0..cols{
                let mut sum = 0 as f64;
                for k in 0..cols{
                    sum += self.get(i,k)*b.get(j,k);
                }
                c.set(i,j,sum);
            }
        }
        c
    }
}