use structs::Matrix;

pub trait ParallelExecution{
    fn run(& mut self , num :i64, num_threads :i32) -> f64;
}

pub trait MatrixMult{
    fn mult(&self,b:&Matrix) -> Matrix;
}

pub trait ParallelMatrixMult{
    fn parallel_mult(&self,b:&Matrix,num_threads:i32) -> Matrix;

    fn parallel_mult_row_threads(&self,b:&Matrix) -> Matrix;

    fn parallel_transpose_mult(&self,b:&Matrix,num_threads:i32) -> Matrix;
}

pub trait Print{
    fn print(&self);
}