package edu.dhbw.pv;

public class Matrix {
    int n,m;
    double[][] val;
    public Matrix(int n,int m) {
        this( zero(n,m) );
        //this.n = n;
        //this.m = m;
        //val = zero(n,m);
    }
    public Matrix(double[][] mat) {
        val = mat;
        this.n = val.length;
        this.m = val[0].length;
    }
    public static double[][] zero(int n, int m) {
        double[][] mat = new double[n][m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                mat[i][j] = 0.0;
            }
        }
        return mat;
    }
    public static double[][] one(int n, int m) {
        double[][] mat = new double[n][m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if (i == j) {
                   mat[i][j] = 1.0;   
                } else {
                   mat[i][j] = 0.0;
                }
            }
        }
        return mat;
    }
    public static double[][] random(int n, int m) {
        double[][] mat = new double[n][m];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                mat[i][j] = Math.random();
            }
        }
        return mat;
    }
    public Matrix transpose() {
        double[][] mat = new double[m][n];
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                mat[j][i] = val[i][j];
            }
        }
        return new Matrix(mat);
    }
    public String toString() {
        StringBuilder sb = new StringBuilder();
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                sb.append(val[i][j] + " ");
            }
            sb.append("\n");
        }
        return sb.toString();
    }
    public void multiply(Matrix C, Matrix A, Matrix B) {
        for (int i = 0; i < A.val.length; i++) {
            for (int j = 0; j < B.val[0].length; j++) {
                double summe = 0.0;
                assert B.val.length == A.val[0].length;
                for (int k = 0; k < B.val.length; k++) {
                    summe += A.val[i][k] * B.val[k][j];    
                }
                C.val[i][j] = summe;
            }
        }
    }
    @Override
    public boolean equals(Object B) {
        if (! (B instanceof Matrix)) {
            return false;
        }
        Matrix BB = (Matrix)B; 
        if (n != BB.n) {
            return false;
        }
        if (m != BB.m) {
            return false;
        }
        double[][] Bval = BB.val;
        for (int i = 0; i < n; i++) {
            for (int j = 0; j < m; j++) {
                if ( Math.abs(val[i][j] - Bval[i][j]) != 0.0) {
                    return false;                    
                }
            }
        }
        return true;
    }
}
