package edu.dhbw.pv;

public class ParallelMatrix extends Matrix {
    public ParallelMatrix(double[][] mat) {
        super(mat);
    }
    @Override
    public void multiply(Matrix C, Matrix A, Matrix B) {
        Thread[] threads = new Thread[A.val.length];
        for (int i = 0; i < A.val.length; i++) {
            threads[i] = new ZeileMult(C, A, B, i);
            threads[i].start();
        }
        for (int i = 0; i < A.val.length; i++) {
            try {
                threads[i].join();
            } catch (InterruptedException e) {
                e.printStackTrace();
            }
        }
    }
}
class ZeileMult extends Thread {
    Matrix C, A, B;
    int i;
    public ZeileMult(Matrix C, Matrix A, Matrix B, int i) {
        this.C = C; this.A = A; this.B = B;
        this.i = i;
    }
    @Override
    public void run() {
        for (int j = 0; j < B.val[0].length; j++) {
            double summe = 0.0;
            assert B.val.length == A.val[0].length;
            for (int k = 0; k < B.val.length; k++) {
                summe += A.val[i][k] * B.val[k][j];    
            }
            C.val[i][j] = summe;
        }
    }
}