#ifndef ParMultProcBlock_h
#define ParMultProcBlock_h

struct nine_args {
    double* C;
    double* A;
    double* B;
    int m;
    int p;
    int n;
    int i;
    int anzahl;
    int blocksize;
};

/**
 * Parallel Matrix Multiplication. 
 * Using specified number of threads, generating product matrix in blocks.
 * @author Joachim Staats.
 */

class ParMultProcBlock {
public:
/** 
 * Constructor.
 */
    ParMultProcBlock(int threads, int size) : anzahl(threads), blocksize(size){};

/**
 * Performs the multiplication of two matrices.
 * C = A * B.
 * @param C result matrix.
 * @param A matrix.
 * @param B matrix.
 */
    void multiply(double* C, double* A, double* B, int m, int p, int n);
private:
    int anzahl;
    int blocksize;
};

/**
 * It performs a row multiplication.
 */
void* RowMultProcBlock (void *arg);

#endif
