#ifndef ParMultProcTrans_h
#define ParMultProcTrans_h

#include "ParMultProc.h"

/**
 * Parallel Matrix Multiplication. 
 * Using specified number of threads, matrix B is transposed.
 * @author Joachim Staats.
 */

class ParMultProcTrans {
public:
/** 
 * Constructor.
 */
    ParMultProcTrans(int threads) : anzahl(threads){};

/**
 * Performs the multiplication of two matrices, B transposed.
 * C = A * transpose(B).
 * @param C result matrix.
 * @param A matrix.
 * @param B matrix.
 */
    void multiply(double* C, double* A, double* B, int m, int p, int n); 
private:
    int anzahl;
};


/**
 * It performs a row multiplication.
 */
void* RowMultProcTrans (void *arg);

#endif
