#ifndef SeqMultTrans_h
#define SeqMultTrans_h

/**
 * Sequential Matrix Multiplication.
 * Sequential algorithm, matrix B is transposed.
 * @author Joachim Staats.
 */

class SeqMultTrans {
public:
/** 
 * Constructor.
 */
    SeqMultTrans(){;};

/** 
 * Destructor.
 */
    ~SeqMultTrans(){;};

/**
 * Performs the multiplication of two matrices, B transposed.
 * C = A * trans(B).
 * @param C result matrix.
 * @param A matrix.
 * @param B matrix.
 */
    void multiply(double* C, double* A, double* B, int m, int p, int n);
};

#endif
