import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Date;

public class ByteServer {
    public static final int PORT = 65000;
    public static void main(String[] args) {
        try {
            ServerSocket ss = new ServerSocket(PORT);
            System.out.println("Server started on port " + PORT);
            System.out.println("waiting for connection ...");
            Socket s = ss.accept();
            System.out.println("new connection " + s);
            PrintWriter pw = new PrintWriter(
                                             new OutputStreamWriter(s.getOutputStream()));
            pw.println("ByteServer ready 1.0");
            pw.println("date: " + new Date());
            pw.println("");
            pw.flush();
            BufferedReader br = new BufferedReader(
                                                   new InputStreamReader(s.getInputStream()));
            String method = br.readLine(); // GET path
            System.out.println("method: " + method);
            String path = method.substring(4);
            System.out.println("path: " + path);
            // remove ../../ from path
            // path = "document-root/" + path;
            BufferedReader fr = new BufferedReader(
                                                   new FileReader(path));
            while (true) {
                String f = fr.readLine();
                if ( f == null ) {
                    break;
                }
                pw.println(f);
            }
            pw.flush();
            pw.close();
            s.close();
        } catch (IOException e) {
            System.out.println("IOException " + e);
            e.printStackTrace();
        }
    }

}
