import java.io.IOException;
import java.io.Serializable;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.concurrent.Callable;

public class DistMaster {
    final static int PORT = 65000;
    public static void main(String[] args) 
        throws IOException, ClassNotFoundException, InterruptedException {
        //ServerSocket ss = new ServerSocket(PORT);
        ChannelFactory cf = new ChannelFactory(PORT);
        System.out.println("server started at " + cf);
        int runner = 2;
        ObjectChannel[] oc = new ObjectChannel[runner];
        for (int i = 0; i < runner; i++) {
            //Socket s = ss.accept();
            //oc[i] = new ObjectChannel(s);
            oc[i] = cf.getChannel();
        }
        System.out.println("Distributed system initialized");
        int aufgaben = 30;
        int max = 100;
        for (int i = 0; i < aufgaben; i++) {
            MultRun m = new MultRun((int)(max*Math.random()),
                                    (int)(max*Math.random()));
            oc[i % runner].send(m);
        }
        System.out.println("send Mult");
        for (int i = 0; i < aufgaben; i++) {
            Object o = oc[i % runner].receive();
            System.out.println("recieved: " + o);
        }
        Schluss s = new Schluss();
        for (int i = 0; i < runner; i++) {
            oc[i].send(s);
            oc[i].close();
        }
        cf.terminate();
        System.out.println("Schluss");
    }
}

class Mult implements Serializable, Callable {
    int x;
    int y;
    public Mult(int x, int y) {
        this.x = x;
        this.y = y;
    }
    public Object call() {
        Integer z = new Integer(x*y);
        return z;
    }
    public String toString() {
        return "x("+x+"), y("+y+")";
    }
}

class MultRun implements Serializable, Runnable {
    int x;
    int y;
    int z;
    public MultRun(int x, int y) {
        this.x = x;
        this.y = y;
    }
    public void run() {
        z = x*y;
    }
    public String toString() {
        return "x("+x+"), y("+y+"), z("+z+")";
    }
}

class Schluss implements Serializable, Runnable {
    public void run() {
        throw new RuntimeException("Schluss");
    }
}
