import java.io.*;
import java.net.*;

/**
 * Hello World Server.
 * Generates a serverside socket "ServerSocket" object on a
 * desired port, displays the server status and a recieved message.
 * @author Heinz Kredel.
 */
public class HelloWorldServ {

    static int port = 40000; // desired server port

/**
 * @param args port
 */
    public static void main(String[] args) {

        try {
            ServerSocket so = new ServerSocket( port ); 
            System.out.println("Server startet on port "+port);

            while (true) {

                    System.out.println("waiting for connection ... ");
                    Socket s = so.accept();
                    System.out.println("new connection from " 
                                      +  s.getInetAddress() );
                    
                    SocketChannel c = new SocketChannel(s);
                    System.out.println("Object Stream created "); 
                    
                    Object o = c.receive();
                    System.out.println("message 1 " + o); 

                    o = c.receive();
                    System.out.println("message 2 " + o); 

                    c.close();

            }


        } catch (IOException e) {
            System.out.println("IOException "+e);
        }
        catch (ClassNotFoundException e) {
            System.out.println("ClassNotFoundException "+e);
        }

    }


}
