import java.io.BufferedReader;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.Date;

public class ObjectServer {
    public static final int PORT = 65000;
    public static void main(String[] args) {
        try {
            ServerSocket ss = new ServerSocket(PORT);
            System.out.println("Server started on port " + PORT);
            System.out.println("waiting for connection ...");
            Socket s = ss.accept();
            System.out.println("new connection " + s);
            ObjectChannel oc = new ObjectChannel(s);
            oc.send("ByteServer ready 1.0");
            oc.send("date: " + new Date());
            oc.send("");
            //pw.flush();
            String method = (String) oc.receive(); //br.readLine(); // GET path
            System.out.println("method: " + method);
            String path = method.substring(4);
            System.out.println("path: " + path);
            // remove ../../ from path
            // path = "document-root/" + path;
            BufferedReader fr = new BufferedReader(
                                                   new FileReader(path));
            while (true) {
                String f = fr.readLine();
                if ( f == null ) {
                    break;
                }
                oc.send(f); //pw.println(f);
            }
            //pw.flush();
            oc.close();
            System.out.println("sleeping ...");
            try {
                Thread.sleep( 10 );
            } catch (InterruptedException e) {
                System.out.println("Dies sollte nicht passieren "+e);
            }
            System.out.println("... done");
            s.close();
        } catch (IOException e) {
            System.out.println("IOException " + e);
            e.printStackTrace();
        } catch (ClassNotFoundException e) {
            e.printStackTrace();
        }
    }

}
