
/**
 * Sequential Matrix Multiplication.
 * Sequential algorithm, generating product matrix in blocks. 
 * matrix B transposed.  
 * @author Heinz Kredel.
 */

public class SeqMultBlockTrans implements MMInf {

    int blocksize = 1;

    public SeqMultBlockTrans(int size) {
         this.blocksize = size;	
    }


/**
 * Performs the multiplication of two matrices, B transposed.
 * C = A * trans(B).
 * @param C result matrix.
 * @param A matrix.
 * @param B matrix.
 */
    public void multiply(double[][] C, double[][] A, double[][] B) {

      int na = blocksize;
      int nb = blocksize;
      System.out.println("#blocks = " + (A.length/na) + ", na = " + na 
          + " SeqMultBlockTrans");

      for (int ii=0; ii < A.length; ii+=na) {
          for (int jj=0; jj < B.length; jj+=nb) {

              for (int i=ii; i < Math.min((ii+na),A.length); i++) {
                  double[] Ai = A[i];
                  for (int j=jj; j < Math.min((jj+nb),B.length); j++) {
                      double[] Bj = B[j];
                      double c = 0.0;
                      for (int k=0; k < Bj.length; k++) {
                          c += Ai[k] * Bj[k];
                      }
                      C[i][j] = c;
                  }
              }

          }
      }

    }

}
