/**
 * Sequential Matrix Multiplication.
 * Sequential algorithm, matrix is B transposed.  
 * @author Heinz Kredel.
 */
public class SeqMultTrans implements MMInf {

/**
 * Performs the multiplication of two matrices, B transposed.
 * C = A * trans(B).
 * @param C result matrix.
 * @param A matrix.
 * @param B matrix.
 */
    public void multiply(double[][] C, double[][] A, double[][] B) {
      System.out.println("SeqMultTrans");
      for (int i=0; i < A.length; i++) {
          double[] Ai = A[i];
          for (int j=0; j < B.length; j++) {
              double[] Bj = B[j];
              double c = 0.0;
              for (int k=0; k < B[0].length; k++) {
                  c += Ai[k] * Bj[k];
              }
              C[i][j] = c;
          }
      }
    }

}
