package edu.dhbw.pv;

import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.BlockingQueue;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.ExecutorService;
import java.util.concurrent.Executors;
import java.util.concurrent.Future;
import java.util.concurrent.LinkedBlockingQueue;

public class Uebung6 {
    public static void main(String[] args) throws InterruptedException, ExecutionException {
        BlockingQueue<Item> bq = new LinkedBlockingQueue<Item>();
        //BlockingQueue<Item> bq = new ArrayBlockingQueue<Item>(100);
        ExecutorService pool = Executors.newCachedThreadPool();
        int anzahl = 20;
        int max = 1000;
        Future [] zukunft = new Future[anzahl];
        int i =0;
        for (i = 0; i < anzahl/3; i++) {
            zukunft[i] = pool.submit(new Producer(i,max,bq));
        }
        for (; i < anzahl; i++) {
            zukunft[i] = pool.submit(new Consumer(i,max,bq));
        }
        long a = 0;
        for (i = 0; i < anzahl/3; i++) {
            a += (Long)zukunft[i].get();
        }
        int k = i;
        for (; k < anzahl; k++) {
            bq.put( new Schluss(0.0) );
        }
        long b = 0;
        for (; i < anzahl; i++) {
            b += (Long)zukunft[i].get();
        }
        pool.shutdown();
        System.out.println("bq = " + bq);
        System.out.println("a = " + a + ", b = " + b);
    }
}
class Producer implements Callable<Long> {
    long ret = 0;
    int i; 
    int max;
    BlockingQueue bq;
    public Producer(int i, int max, BlockingQueue bq) {
        this.i = i;
        this.bq = bq;
        this.max = max;
    }
    public Long call() throws InterruptedException {
        System.out.println("Producer start " + i);
        for (int j = 0; j < max; j++) {
            bq.put( new Item( Math.sin(i+j) ) );
        }
        System.out.println("Producer stop  " + i);
        ret = max;
        return ret;
    }
}
class Consumer implements Callable<Long> {
    long ret = 0;
    int i;
    int max;
    BlockingQueue bq;
    public Consumer(int i, int max, BlockingQueue bq) {
        this.i = i;
        this.bq = bq;
        this.max = max;
    }
    public Long call() throws InterruptedException {
        System.out.println("Consumer start " + i);
        double sum = 0.0;
        int j = 0;
        for (j = 0; j < max; j++) {
            Item it = (Item)bq.take();
            if (it instanceof Schluss) {
                break;
            }
            sum += it.d;
        }
        ret = j;
        System.out.println("Consumer stop  " + i + ", work " + j);
        return ret;
    }
}
class Item {
    double d;
    public Item(double d) {
        this.d = d;
    }
    public String toString() {
        return " " + d;
    }
}
class Schluss extends Item {
    public Schluss(double d) {
        super(d);
    }
}