
package util;

/**
 * dummy logger, somewhat compatible with log4j.
 * @author Heinz Kredel.
 */
public class Logger {

    private int level = 2;

    public Logger() {
        level = 1;
    }

/**
 * @param le new level.
 */
    public Logger(int le) {
        level = le;
    }

/**
 * @return true if debug level is enabled.
 */
    public boolean isDebugEnabled() {
        return (level > 2);
    }

/**
 * @param msg message to log.
 */
    public void debug( String msg ) {
        if ( level > 2 ) {
           System.out.println("debug: "+msg);
        }
    }

/**
 * @param msg message to log.
 */
    public void info( String msg ) {
        if ( level > 1 ) {
           System.out.println("info: "+msg);
        }
    }

/**
 * @param msg message to log.
 */
    public void warn( String msg ) {
        if ( level > 0 ) {
           System.out.println("warning: "+msg);
        }
    }

}